<?php
/* HTMLConverter - Simple HTML to PDF/RTF/TXT/etc converter
 * Copyright 2004-2006, Steve Blinch
 * http://code.blitzaffe.com
 * ============================================================================
 *
 * NOTES
 *
 * This class is *very* rough, and was hastily translated from some Delphi code
 * I previously wrote.  Proceed at own risk.  :)
 *
 *
 * LICENSE
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */ 
/*
const
  RTF_Start     = "{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang1033%s\r\n\\pard"; // FontTbl, FontSize
  RTF_FontTbl   = "{\\fonttbl%s}"; // one or more font entries
  RTF_FontEntry = "{\\f%d\\f%s %s;}"; // font number, font type, font name

  RTF_StyleSheet= "{\\stylesheet%s}";
  RTF_Headings  = "{ Normal;}{\\s1 cracky;}{\\s2 heading 1;}{\\s3 heading 2;}{\\s4 heading 3;}{\\s5 heading 4;}{\\s6 heading 5;}{\\s7 heading 6;}{\\s8 heading 7;}{\\s9 heading 8;}';

  RTF_Para      = "\\par ";
  RTF_ParaDef   = "\\pard";

  RTF_SetIndent = "\\fi%d\\li%d\\tx%d";
  RTF_Bold      = "\\b";
  RTF_Italic    = "\\i";
  RTF_Underline = "\\u";
  RTF_FontSize  = "\\fs%d";
  RTF_FontClear = "\\f0";
  RTF_SetFont   = "\\f%d";
  RTF_Tab       = "\\tab";

  RTF_MarginTop = "\\margt%d";
  RTF_MarginBot = "\\margb%d";
  RTF_MarginLft = "\\margl%d";
  RTF_MarginRgt = "\\margr%d";

  RTF_SpcBefore = "\\sb%d";
  RTF_SpcAfter  = "\\sa%d";

  RTF_TabStop   = "\\tx%d";
  RTF_TabCenter = "\\tqc";
  RTF_TabLeft   = "\\tql";
  RTF_TabRight  = "\\tqr";

  RTF_PageBreak = "\\page";
  
  RTF_HdrStart  = "{\\header ";
  RTF_HdrFinish = "}";

  RTF_FtrStart  = "{\\footer ";
  RTF_FtrFinish = "}";

  RTF_HideStart = "{\\v ";
  RTF_HideFinish= "}";

  RTF_SetStyle  = "\\s%d";

  RTF_Finish    = "}";

  CRLF          = #13#10;

 
  RTF_ListText  = RTF_Para+'{\listtext\pard\plain \hich\af0\dbch\af0\loch\f0 %s\tab}%s';

  RTF_ListTable = '{\*\listtable %s}';           // %s=list
  RTF_List      = '{\list\listtemplateid%d %s}'; // random unique number
  RTF_ListLevel = '{\listlevel\levelnfc%d\levelnfcn%d\leveljc%d\leveljcn%d\levelfollow%d\levelstartat%d\levelspace%d\levelindent%d %s}'; // %s=leveltext and/or levelnumbers
  RTF_LevelText = '{\leveltext%s;}';
  RTF_LevelNums = '{\levelnumbers%s;}';
  
  RTF_IndentFL  = '\fi%d';
  RTF_IndentLft = '\li%d';
  RTF_IndentRgt = '\ri%d';
  RTF_TabPos    = '\tx%d';

  RTF_ListOvrTbl = '{\*\listoverridetable %s}';
  RTF_ListOvr   = '{\listoverride\listid%d\listoverridecount%d\ls%d}';

  lvNumArabic   = 0;    // 1, 2, 3
  lvNumUpRoman  = 1;    // I, II, III
  lvNumLoRoman  = 2;    // i, ii, iii
  lvNumUpLetter = 3;    // A, B, C
  lvNumLoLetter = 4;    // a, b, c
  lvNumOrdNum   = 5;    // 1st, 2nd, 3rd
  lvNumCardText = 6;    // One, Two, Three
  lvNumOrdText  = 7;    // First, Second Third
  lvNumArabZero = 22;   // 01, 02, 03
  lvNumBullet   = 23;   // Bullet, no number
  lvNumNoNumber = 255;  // No number

  lvJustLeft    = 0;
  lvJustCenter  = 1;
  lvJustRight   = 2;

  lvFollowTab   = 0;
  lvFollowSpc   = 1;
  lvFollowNone  = 2;
*/

class RTF {

	function RTF() {
		$this->break_output = true;
		$this->clear();
	}
	
	function reset_tabs() {
		/*
		$this->first_indent = -$this->INDENT_INCREMENT;
		$this->left_indent = $this->INDENT_INCREMENT;
		$this->tab_indent = $this->INDENT_INCREMENT;
		*/
		$this->first_indent = $this->left_indent = $this->tab_indent = 0;
	}
	
	function text($s) {
		$c = substr($this->rtf_output,-1);
		if (strpos("} \n",$c)===false) $s = " $s";
		$this->output($s);
	}
	
	function output($s) {
		$this->rtf_output .= $s;
		$this->linelen += strlen($s);
		if ($this->break_output && $this->linelen>100) {
			$this->rtf_output .= "\r\n";
			$this->linelen = 0;
		}
	}
	
/*	
	function get_list_tables() {
		$fi = array(-720,-360,-180,-360,-360,-180,-360,-360,-180);
  		$li = array(2160,2520,3240,3960,4680,5400,6120,6840,7560);
		$LIST_LEVELS = count($fi);

		$lid = array();

		//  List,ListLevel,LevelInfo: String;
		$randmax = getrandmax();
		
		for ($i=0; $i<$LIST_LEVELS; $i++) {
			$lid[$i] = rand(0,$randmax);
			$level_info = 
			
			
      LevelInfo:=Format(RTF_LevelText,['\''02\''00.'])+
                 Format(RTF_LevelNums,['\''01'])+
                 '\fbias0 '+
                 Format(RTF_IndentFL,[fi[i]])+
                 Format(RTF_IndentLft,[li[i]])+
                 '\jclisttab '+
                 Format(RTF_TabPos,[0]);
    //             +'\lin????';

      ListLevel:=ListLevel+Format(RTF_ListLevel,
        [
        lvNumArabic,  // number style
        0,            // unknown
        lvJustLeft,   // justification
        0,            // unknown
        lvFollowTab,  // character following level text
        0,            // numbering starts at...
        0,            // dist from right edge to paragraph start
        0,            // dist from left indent to start
        LevelInfo
        ])+#13#10;
    end;

  List:=Format(RTF_List,[Random(MaxInt),ListLevel]);
  RTF_ListOvrTbl = '{\*\listoverridetable %s}';
  RTF_ListOvr   = '{\listoverride\listid%d\listoverridecount%d\ls%d}';

  {\*\listoverridetable
	{\listoverride\listid1684548719\listoverridecount0\ls1}
	{\listoverride\listid1549412887\listoverridecount0\ls2}
	{\listoverride\listid570653368\listoverridecount0\ls3}
	{\listoverride\listid350299950\listoverridecount0\ls4}
	{\listoverride\listid1151361787\listoverridecount0\ls5}
}

  Result:=Format(RTF_ListTable,[List]);
  *)
end;
*/


	function start($font_list,$default_font_idx,$default_font_size,$landscape) {

		$font_list[] = "Symbol";
		
		$i=0;
		foreach ($font_list as $k=>$font) {
			$fl .= sprintf("{\\f%d\\f%s %s;}",$i,'nil',$font);
			$this->font_list_table[] = strtolower($font);
			$i++;
		}
		
		$this->symbol_font = $i-1;
		
		
		$font_table = sprintf("{\\fonttbl%s}",$fl);

		$this->output(sprintf("{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang1033%s\r\n\\pard",$font_table));
		
		$this->color_table = array();
		$this->color_lookup = array();
		$this->output("{%~%COLORTABLE%~%}");
		
		
		$rtf_headings = "{ Normal;}{\\s1 cracky;}{\\s2 heading 1;}{\\s3 heading 2;}{\\s4 heading 3;}{\\s5 heading 4;}{\\s6 heading 5;}{\\s7 heading 6;}{\\s8 heading 7;}{\\s9 heading 8;}";
		$this->output(sprintf("{\\stylesheet%s}",$rtf_headings));
		
		
		if ($landscape) {
			$w = 11;
			$h = 8.5;
		} else {
			$w = 8.5;
			$h = 11;
		}
		$this->page_width = floor($w * 1440);
		$this->page_height = floor($h * 1440);

		$this->output("\\paperw{$this->page_width}\\paperh{$this->page_height}");
		if ($landscape) {
			$this->output("\\sectd \\lndscpsxn");
		}
		
		$this->reset_tabs();
		$this->set_indent($this->first_indent,$this->left_indent,$this->tab_indent);
		
		$this->set_font($default_font_idx);
		$this->set_font_size($default_font_size);
		$this->set_color(0,0,0);
		
	}
	
	function finish() {
		$this->output("}");
		
		// now that we're done, fill in the color table
		$color_table = "{\\colortbl;";
		foreach ($this->color_table as $idx=>$colors) {
			list($r,$g,$b) = $colors;
			$color_table .= "\\red{$r}\\green{$g}\\blue{$b};";
		}
		$color_table .= "}";
		
		$this->rtf_output = str_replace("{%~%COLORTABLE%~%}",$color_table,$this->rtf_output);
	}
	
	function clear() {
		$this->rtf_output = "";
		$this->linelen = 0;
		
		$this->INDENT_INCREMENT = 480;
		
		$this->first_indent = 0;
		$this->left_indent = 0;
		$this->tab_indent = 0;

		$this->font_list_table = array();
		$this->list_levels = array();

		$this->reset_tabs();
	}
	

	function get() {
		return $this->rtf_output;
	}
	
	function save($filename) {
		$fp = fopen($filename,"w");
		if ($fp) {
			fwrite($fp,$this->rtf_output);
			fclose($fp);
			
			return true;
		} else {
			return false;
		}
	}
	
	

	function set_font($font_idx) {
		$this->current_font = $font_idx;
		$this->output(sprintf("\\f%d",$font_idx));
	}
	
	function set_font_by_name($font_name) {
		$font_name = strtolower($font_name);
		reset($this->font_list_table);
		$k = array_search($font_name,$this->font_list_table);
		if ($k) $this->set_font($k);
	}
	
	function inc_indent() {
		$this->left_indent += $this->INDENT_INCREMENT;
		$this->tab_indent += $this->INDENT_INCREMENT;
		$this->set_indent($this->first_indent,$this->left_indent,$this->tab_indent);
	}
	
	function dec_indent() {
		$this->left_indent -= $this->INDENT_INCREMENT;
		$this->tab_indent -= $this->INDENT_INCREMENT;
		$this->set_indent($this->first_indent,$this->left_indent,$this->tab_indent);
	}
	
	function set_indent($first,$left,$tab) {
		$this->output(sprintf("\\fi%d\\li%d\\tx%d",$first,$left,$tab));
	}
	
	function unformat($s) {
		return str_replace("%","%%",$s);
	}
	
	function paragraph($s="") {
		$this->output("\\par ".$this->unformat($s));
	}
	
	function set_font_size($new_size) {
		$this->output(sprintf("\\fs%d",$new_size*2));
		$this->current_font_size = $new_size;
	}
	
	function bold($activate) {
		$this->output("\\b".($activate?"":"0"));
	}

	function italic($activate) {
		$this->output("\\i".($activate?"":"0"));
	}

	function underline($activate) {
		$this->output("\\ul".($activate?"":"0"));
	}
	
	function font_clear() {
		$this->set_font(0);
	}
	
	function header_start() {
		$this->output("{\\header ");
	}
	
	function header_finish() {
		$this->output("}");
	}
	
	function footer_start() {
		$this->output("{\\footer ");
	}
	
	function footer_end() {
		$this->output("}");
	}
	
	function set_margins($left,$right,$top,$bottom) {
		foreach (array("left","right","top","bottom") as $margin) $this->set_margin($margin,$$margin);
		//$this->set_indent($this->first_indent,$this->left_indent,$this->tab_indent);
	}
	
	function set_margin($margin,$value) {
		$margins = array(
			"top"=>"\\margt%d",
			"left"=>"\\margl%d",
			"right"=>"\\margr%d",
			"bottom"=>"\\margb%d"
		);
		$rtf_margin = $margins[$margin];
		if ($rtf_margin) $this->output(sprintf($rtf_margin,$value));
		$this->margins[$margin] = $value;
	}
	
	function line_spacing($value,$which="both") {
		if ($which=="below" || $which=="both") $this->output(sprintf("\\sb%d",$value));
  		if ($which=="above" || $which=="both") $this->output(sprintf("\\sa%d",$value));
	}
	
	function default_paragraph() {
		$this->output("\\pard");
	}
	
	function set_tab_stop($position) {
		$this->output(sprintf("\\tx%d",$position));
	}
	
	function set_tab($tabtype) {
		$tabtypes = array(
			"center"=>"\\tqc",
			"left"=>"\\tql",
			"right"=>"\\tqr"
		);
		
		$tab = $tabtypes[$tabtype];
		if ($tab) $this->output($tab);
	}
	
	function tab() {
		$this->output("\\tab");
	}
	
	function page_break() {
		$this->output("\\page");
	}
	
	function get_page_number() {
		return "{\\field{\\*\\fldinst PAGE }{\\fldrslt }}";
	}
	
	function page_number() {
		$this->output($this->get_page_number());
	}
	
	function get_page_count() {
		return "{\\field{\\*\\fldinst NUMPAGES }{\\fldrslt }}";
	}
	
	function page_count() {
		$this->output($this->get_page_count());
	}
	
	function section_break() {
		$this->output(" \\sect ");
	}
	
	function set_style($styleno) {
		$this->output("\\s%d",$styleno);
	}
	
	function hide($activate) {
		if ($activate) {
			$this->output("{\\v ");
		} else {
			$this->output("}");
		}
	}
	
	function set_align($alignment) {
		$alignments = array(
			"left"=>"\\ql",
			"right"=>"\\qr",
			"center"=>"\\qc"
		);
		$rtf_align = $alignments[$alignment];
		if ($rtf_align) $this->output($rtf_align);
	}
	
	// styles available:
	//	bulleted
	//	numeric
	//	alphaupper
	//	alphalower
	function list_start($list_style="numeric",$list_format=NULL) {
		
		if (is_null($list_format)) {
			switch($list_style) {
				case "alphalower":
				case "alphaupper":
					$list_format = "%s.";
					break;
				case "bulleted":
					$list_format = "%s";
					break;
				default:
					$list_format = "%d.";
					break;
			}
		}
		$list_level = array(
			"style"=>$list_style,
			"index"=>0,
			"format"=>$list_format,
		);
		array_unshift($this->list_levels,$list_level);
		$this->inc_indent();
		if (count($this->list_levels)==1) $this->output(" ");
	}


	function list_finish() {
		$list_level = array_shift($this->list_levels);
		if ($list_level) $this->dec_indent();
		if (!count($this->list_levels)) {
			$this->default_paragraph();
		} else {
			$this->output(" ");
		}
	}
	
	function list_item($item) {
		$list_level = &$this->list_levels[0];

		$list_level["index"]++;
		$index = $list_level["index"];
		switch($list_level["style"]) {
			case "numeric":
				$bullet = $index; break;
			case "alphalower":
				$bullet = chr(ord('a')+$index-1); break;
			case "alphaupper":
				$bullet = chr(ord('A')+$index-1); break;
			case "bulleted":
				$bullet = "\\bullet"; break;
		}
	
		$this->output(
			sprintf($list_level["format"],$bullet).
			"\\tab ".
			$this->unformat($item).
			"\\par \r\n"
		);

	}	

	function set_color($r,$g,$b) {
		$rgb = $r.".".$g.".".$b;
		if (isset($this->color_lookup[$rgb])) {
			$idx = $this->color_lookup[$rgb];
		} else {
			$idx = count($this->color_table);
			$this->color_table[$idx] = array($r,$g,$b);
			$this->color_lookup[$rgb] = $idx;
		}
		$idx++;
		$this->output("\\cf{$idx}");
	}

}

?>